Bug 20691 - Add ability for guarantors to view guarantee's fines in OPAC
Summary: Add ability for guarantors to view guarantee's fines in OPAC
Status: Pushed to master
Alias: None
Product: Koha
Classification: Unclassified
Component: OPAC (show other bugs)
Version: master
Hardware: All All
: P5 - low enhancement (vote)
Assignee: Kyle M Hall
QA Contact: Tomás Cohen Arazi
URL:
Keywords: Manual, release-notes-needed
Depends on: 14570
Blocks: 20211 23214 23623
  Show dependency treegraph
 
Reported: 2018-05-01 17:00 UTC by Kyle M Hall
Modified: 2019-09-17 13:48 UTC (History)
6 users (show)

See Also:
Change sponsored?: ---
Patch complexity: ---
Who signed the patch off:
Text to go in the release notes:
Version(s) released in:
19.11.00


Attachments
Bug 20691: Database update (6.26 KB, patch)
2018-05-02 13:13 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 20691: Update Schema Files (4.33 KB, patch)
2018-05-02 13:13 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 20691: Add ability to turn feature on and off (20.13 KB, patch)
2018-05-02 13:13 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 20691 - Implement fines view (10.64 KB, patch)
2018-05-02 13:13 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 20691: Database update (6.26 KB, patch)
2018-05-02 13:16 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 20691: Update Schema Files (4.33 KB, patch)
2018-05-02 13:16 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 20691: Add ability to turn feature on and off (20.13 KB, patch)
2018-05-02 13:16 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 20691: Implement fines view (9.80 KB, patch)
2018-05-02 13:16 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 20691: Database update (6.24 KB, patch)
2019-05-22 06:22 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: Add ability to turn feature on and off (21.88 KB, patch)
2019-05-22 06:22 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: Implement fines view (8.87 KB, patch)
2019-05-22 06:22 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: Database update (6.24 KB, patch)
2019-05-23 03:24 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: Add ability to turn feature on and off (22.31 KB, patch)
2019-05-23 03:24 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: Implement fines view (8.87 KB, patch)
2019-05-23 03:24 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: (follow-up) Fix qa fails (5.08 KB, patch)
2019-05-23 03:24 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: Database update (6.24 KB, patch)
2019-05-24 23:42 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: Add ability to turn feature on and off (26.21 KB, patch)
2019-05-24 23:42 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: Implement fines view (9.47 KB, patch)
2019-05-24 23:42 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: (follow-up) Fix qa fails (4.13 KB, patch)
2019-05-24 23:42 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: Implement fines view (8.40 KB, patch)
2019-06-26 18:12 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: (follow-up) Fix qa fails (3.78 KB, patch)
2019-06-26 18:12 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: Database update (6.30 KB, patch)
2019-07-01 19:28 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: Add ability to turn feature on and off (26.04 KB, patch)
2019-07-01 19:28 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: Implement fines view (8.46 KB, patch)
2019-07-01 19:28 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: (follow-up) Fix qa fails (3.78 KB, patch)
2019-07-01 19:28 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: Database update (6.30 KB, patch)
2019-08-20 18:24 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: Add ability to turn feature on and off (26.05 KB, patch)
2019-08-20 18:24 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: Implement fines view (8.47 KB, patch)
2019-08-20 18:24 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: (follow-up) Fix qa fails (3.78 KB, patch)
2019-08-20 18:24 UTC, Agustín Moyano
Details | Diff | Splinter Review
Bug 20691: (follow-up) Fix qa fails (3.85 KB, patch)
2019-08-28 10:20 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 20691: Database update (6.35 KB, patch)
2019-09-10 18:32 UTC, Tomás Cohen Arazi
Details | Diff | Splinter Review
Bug 20691: Add ability to turn feature on and off (26.10 KB, patch)
2019-09-10 18:32 UTC, Tomás Cohen Arazi
Details | Diff | Splinter Review
Bug 20691: Implement fines view (8.09 KB, patch)
2019-09-10 18:32 UTC, Tomás Cohen Arazi
Details | Diff | Splinter Review
Bug 20691: (follow-up) Fix qa fails (3.83 KB, patch)
2019-09-10 18:32 UTC, Tomás Cohen Arazi
Details | Diff | Splinter Review
Bug 20691: (QA follow-up) Fix atomic update (2.97 KB, patch)
2019-09-10 18:32 UTC, Tomás Cohen Arazi
Details | Diff | Splinter Review
Bug 20691: (QA follow-up) API-related fixes (1.62 KB, patch)
2019-09-10 18:33 UTC, Tomás Cohen Arazi
Details | Diff | Splinter Review
Bug 20691: (QA follow-up) Fix self-reg (1.21 KB, patch)
2019-09-17 13:45 UTC, Tomás Cohen Arazi
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Kyle M Hall 2018-05-01 17:00:10 UTC

    
Comment 1 Kyle M Hall 2018-05-02 13:13:42 UTC
Created attachment 74968 [details] [review]
Bug 20691: Database update
Comment 2 Kyle M Hall 2018-05-02 13:13:48 UTC
Created attachment 74969 [details] [review]
Bug 20691: Update Schema Files
Comment 3 Kyle M Hall 2018-05-02 13:13:51 UTC
Created attachment 74970 [details] [review]
Bug 20691: Add ability to turn feature on and off
Comment 4 Kyle M Hall 2018-05-02 13:13:53 UTC
Created attachment 74971 [details] [review]
Bug 20691 - Implement fines view
Comment 5 Kyle M Hall 2018-05-02 13:16:44 UTC
Created attachment 74972 [details] [review]
Bug 20691: Database update
Comment 6 Kyle M Hall 2018-05-02 13:16:51 UTC
Created attachment 74973 [details] [review]
Bug 20691: Update Schema Files
Comment 7 Kyle M Hall 2018-05-02 13:16:53 UTC
Created attachment 74974 [details] [review]
Bug 20691: Add ability to turn feature on and off
Comment 8 Kyle M Hall 2018-05-02 13:16:56 UTC
Created attachment 74975 [details] [review]
Bug 20691: Implement fines view
Comment 9 Cab Vinton 2018-08-30 02:56:00 UTC
The sandbox you've requested is not ready.
Some problems occurred applying patches from bug 20691:
<h1>Something went wrong !</h1>Applying: Bug 20691: Database update
Applying: Bug 20691: Update Schema Files
fatal: sha1 information is lacking or useless (Koha/Schema/Result/Borrower.pm).
error: could not build fake ancestor
Patch failed at 0001 Bug 20691: Update Schema Files
The copy of the patch that failed is found in: .git/rebase-apply/patch
When you have resolved this problem run git bz apply --continue.
If you would prefer to skip this patch, instead run git bz apply --skip.
To restore the original branch and stop patching run git bz apply --abort.
Bug 20691 - Add ability for guarantors to view guarantee's fines in OPAC

74972 - Bug 20691: Database update
74973 - Bug 20691: Update Schema Files
74974 - Bug 20691: Add ability to turn feature on and off
74975 - Bug 20691: Implement fines view

Apply? [(y)es, (n)o, (i)nteractive] Patch left in /tmp/Bug-20691-Update-Schema-Files-nJNDYm.patch .
Comment 10 Agustín Moyano 2019-05-22 06:22:43 UTC
Created attachment 89951 [details] [review]
Bug 20691: Database update
Comment 11 Agustín Moyano 2019-05-22 06:22:48 UTC
Created attachment 89952 [details] [review]
Bug 20691: Add ability to turn feature on and off
Comment 12 Agustín Moyano 2019-05-22 06:22:52 UTC
Created attachment 89953 [details] [review]
Bug 20691: Implement fines view
Comment 13 Agustín Moyano 2019-05-22 06:23:59 UTC
Patches now apply, but I'm not sure how to test it.. for there is no test plan.

Agustín
Comment 14 Agustín Moyano 2019-05-23 03:24:38 UTC
Created attachment 89990 [details] [review]
Bug 20691: Database update
Comment 15 Agustín Moyano 2019-05-23 03:24:43 UTC
Created attachment 89991 [details] [review]
Bug 20691: Add ability to turn feature on and off
Comment 16 Agustín Moyano 2019-05-23 03:24:47 UTC
Created attachment 89992 [details] [review]
Bug 20691: Implement fines view
Comment 17 Agustín Moyano 2019-05-23 03:24:51 UTC
Created attachment 89993 [details] [review]
Bug 20691: (follow-up) Fix qa fails
Comment 18 Agustín Moyano 2019-05-23 03:31:34 UTC
I tested it roughly, and works.. I'll try to write a test plan tomorrow.
Comment 19 Agustín Moyano 2019-05-24 23:42:33 UTC
Created attachment 90093 [details] [review]
Bug 20691: Database update
Comment 20 Agustín Moyano 2019-05-24 23:42:38 UTC
Created attachment 90094 [details] [review]
Bug 20691: Add ability to turn feature on and off

This patch adds two preferences
1. AllowPatronToSetFinesVisibilityForGuarantor: Allow/Don't allow patrons to choose their own privacy settings for showing the patron's fines to the patron's guarantor
2. AllowStaffToSetFinesVisibilityForGuarantor: Allow/Don't allow staff to set the ability for a patron's fines to be viewed by linked patrons in the OPAC

Also adds a tinyint, non nullable, default to 0 column in borrower and deletedborrower named privacy_guarantor_fines.
1. privacy_guarantor_fines = 0 => don't allow guarantor to see guarantee's fines
2. privacy_guarantor_fines = 1 => allow guarantor to see guarantee's fines

To test:
1) git reset --hard master
2) apply patches (including dependencies)
3) perl installer/data/mysql/updatedatabase.pl
4) dbic
5) restart_all
6) in intranet search for AllowPatronToSetFinesVisibilityForGuarantor and AllowStaffToSetFinesVisibilityForGuarantor preferences
SUCCESS => both preferences should be present
7) search for a patron with guarantor
SUCCESS => in details tab, in "Library use" section you should see a row labeled "Show fines to guarantor"
8) edit
CHECK => in Guarantor information there is no "Show fines to guarantor" select
9) set AllowStaffToSetFinesVisibilityForGuarantor preference to "Allow"
10) return to patron with guarantor and edit
SUCCESS => in Guarantor information section there is a "Show fines to guarantor" select
11) change "Show fines to guarantor" select to "Yes" and save
SUCCESS => Value is saved
12) go to details tab
SUCCESS => in "Library use" section you see a row labeled "Show fines to guarantor" with value "Yes"
13) set OPACPrivacy preference to "Allow"
14) open 2 opacs, one with a patron that has a guarantor and another that hasn't and go to "your privacy" tab.
CHECK => in both opacs you should not see a "Allow your guarantor to view your current fines?" select
15) in intranet set AllowPatronToSetFinesVisibilityForGuarantor to "Allow"
16) refresh both opacs
SUCCESS => in Patron that has guarantor you see a "Allow your guarantor to view your current fines?" select
	=> in Patron without guarantor you don't see a "Allow your guarantor to view your current fines?" select
17) in Patron with guarantor change value of select and save
SUCCESS => Value is saved
18) in intranet set OPACPrivacy preference to "Don't allow" and AllowPatronToSetFinesVisibilityForGuarantor to "Don't allow"
19) got to "your personal details" in both opacs
CHECK => in both opacs you should not see no Privacy section with a "Allow your guarantor to view your current fines?" select
20) in intranet set AllowPatronToSetFinesVisibilityForGuarantor to "Allow"
21) refresh both opacs
SUCCESS => in Patron that has guarantor you see a "Allow your guarantor to view your current fines?" select in a Privacy section
        => in Patron without guarantor there is no Privacy section
22) in Patron with guarantor change value of select and update
SUCCESS => Value is saved
23) Sign off
Comment 21 Agustín Moyano 2019-05-24 23:42:42 UTC
Created attachment 90095 [details] [review]
Bug 20691: Implement fines view

This patch implements the logic to show guarantee's fines with guarantor user.

To test:
1) Apply (if not already done) steps 1 to 5 of previous patch
2) Apply this patch
3) Set OPACFinesTab and AllowStaffToSetFinesVisibilityForGuarantor preference to "Allow"
4) Find a guarantee and in accounting create a manual invoice
5) Enter OPAC with guarantor user
CHECK => In summary there is no "Relatives fines" tab
6) On intranet edit guarantee and set "Show fines to guarantors" to "Yes" and save
7) Reload guarantor's OPAC
SUCCESS => You see a "Relatives fines" tab with guarantee's fines information
8) Sign off
Comment 22 Agustín Moyano 2019-05-24 23:42:46 UTC
Created attachment 90096 [details] [review]
Bug 20691: (follow-up) Fix qa fails
Comment 23 Agustín Moyano 2019-06-26 18:12:38 UTC
Created attachment 91025 [details] [review]
Bug 20691: Implement fines view

This patch implements the logic to show guarantee's fines with guarantor user.

To test:
1) Apply (if not already done) steps 1 to 5 of previous patch
2) Apply this patch
3) Set OPACFinesTab and AllowStaffToSetFinesVisibilityForGuarantor preference to "Allow"
4) Find a guarantee and in accounting create a manual invoice
5) Enter OPAC with guarantor user
CHECK => In summary there is no "Relatives fines" tab
6) On intranet edit guarantee and set "Show fines to guarantors" to "Yes" and save
7) Reload guarantor's OPAC
SUCCESS => You see a "Relatives fines" tab with guarantee's fines information
8) Sign off
Comment 24 Agustín Moyano 2019-06-26 18:12:41 UTC
Created attachment 91026 [details] [review]
Bug 20691: (follow-up) Fix qa fails
Comment 25 Agustín Moyano 2019-07-01 19:28:12 UTC
Created attachment 91159 [details] [review]
Bug 20691: Database update

Signed-off-by: Agustin Moyano <agustinmoyano@theke.io>
Comment 26 Agustín Moyano 2019-07-01 19:28:16 UTC
Created attachment 91160 [details] [review]
Bug 20691: Add ability to turn feature on and off

This patch adds two preferences
1. AllowPatronToSetFinesVisibilityForGuarantor: Allow/Don't allow patrons to choose their own privacy settings for showing the patron's fines to the patron's guarantor
2. AllowStaffToSetFinesVisibilityForGuarantor: Allow/Don't allow staff to set the ability for a patron's fines to be viewed by linked patrons in the OPAC

Also adds a tinyint, non nullable, default to 0 column in borrower and deletedborrower named privacy_guarantor_fines.
1. privacy_guarantor_fines = 0 => don't allow guarantor to see guarantee's fines
2. privacy_guarantor_fines = 1 => allow guarantor to see guarantee's fines

To test:
1) git reset --hard master
2) apply patches (including dependencies)
3) perl installer/data/mysql/updatedatabase.pl
4) dbic
5) restart_all
6) in intranet search for AllowPatronToSetFinesVisibilityForGuarantor and AllowStaffToSetFinesVisibilityForGuarantor preferences
SUCCESS => both preferences should be present
7) search for a patron with guarantor
SUCCESS => in details tab, in "Library use" section you should see a row labeled "Show fines to guarantor"
8) edit
CHECK => in Guarantor information there is no "Show fines to guarantor" select
9) set AllowStaffToSetFinesVisibilityForGuarantor preference to "Allow"
10) return to patron with guarantor and edit
SUCCESS => in Guarantor information section there is a "Show fines to guarantor" select
11) change "Show fines to guarantor" select to "Yes" and save
SUCCESS => Value is saved
12) go to details tab
SUCCESS => in "Library use" section you see a row labeled "Show fines to guarantor" with value "Yes"
13) set OPACPrivacy preference to "Allow"
14) open 2 opacs, one with a patron that has a guarantor and another that hasn't and go to "your privacy" tab.
CHECK => in both opacs you should not see a "Allow your guarantor to view your current fines?" select
15) in intranet set AllowPatronToSetFinesVisibilityForGuarantor to "Allow"
16) refresh both opacs
SUCCESS => in Patron that has guarantor you see a "Allow your guarantor to view your current fines?" select
	=> in Patron without guarantor you don't see a "Allow your guarantor to view your current fines?" select
17) in Patron with guarantor change value of select and save
SUCCESS => Value is saved
18) in intranet set OPACPrivacy preference to "Don't allow" and AllowPatronToSetFinesVisibilityForGuarantor to "Don't allow"
19) got to "your personal details" in both opacs
CHECK => in both opacs you should not see no Privacy section with a "Allow your guarantor to view your current fines?" select
20) in intranet set AllowPatronToSetFinesVisibilityForGuarantor to "Allow"
21) refresh both opacs
SUCCESS => in Patron that has guarantor you see a "Allow your guarantor to view your current fines?" select in a Privacy section
        => in Patron without guarantor there is no Privacy section
22) in Patron with guarantor change value of select and update
SUCCESS => Value is saved
23) Sign off

Signed-off-by: Agustin Moyano <agustinmoyano@theke.io>
Comment 27 Agustín Moyano 2019-07-01 19:28:20 UTC
Created attachment 91161 [details] [review]
Bug 20691: Implement fines view

This patch implements the logic to show guarantee's fines with guarantor user.

To test:
1) Apply (if not already done) steps 1 to 5 of previous patch
2) Apply this patch
3) Set OPACFinesTab and AllowStaffToSetFinesVisibilityForGuarantor preference to "Allow"
4) Find a guarantee and in accounting create a manual invoice
5) Enter OPAC with guarantor user
CHECK => In summary there is no "Relatives fines" tab
6) On intranet edit guarantee and set "Show fines to guarantors" to "Yes" and save
7) Reload guarantor's OPAC
SUCCESS => You see a "Relatives fines" tab with guarantee's fines information
8) Sign off

Signed-off-by: Agustin Moyano <agustinmoyano@theke.io>
Comment 28 Agustín Moyano 2019-07-01 19:28:23 UTC
Created attachment 91162 [details] [review]
Bug 20691: (follow-up) Fix qa fails
Comment 29 Katrin Fischer 2019-08-10 12:41:55 UTC
At the moment this depends on a bug in ASSIGNED status - moving this to BLOCKED.
Please push back into the queues once the depenency has been resolved.
Comment 30 Agustín Moyano 2019-08-16 18:28:22 UTC
Moving this to NOS, for dependency is no longer in ASSIGNED status
Comment 31 Katrin Fischer 2019-08-19 21:04:55 UTC
Please rebase once dependency has been pushed!
Comment 32 Agustín Moyano 2019-08-20 18:24:10 UTC
Created attachment 92385 [details] [review]
Bug 20691: Database update

Signed-off-by: Agustin Moyano <agustinmoyano@theke.io>
Comment 33 Agustín Moyano 2019-08-20 18:24:14 UTC
Created attachment 92386 [details] [review]
Bug 20691: Add ability to turn feature on and off

This patch adds two preferences
1. AllowPatronToSetFinesVisibilityForGuarantor: Allow/Don't allow patrons to choose their own privacy settings for showing the patron's fines to the patron's guarantor
2. AllowStaffToSetFinesVisibilityForGuarantor: Allow/Don't allow staff to set the ability for a patron's fines to be viewed by linked patrons in the OPAC

Also adds a tinyint, non nullable, default to 0 column in borrower and deletedborrower named privacy_guarantor_fines.
1. privacy_guarantor_fines = 0 => don't allow guarantor to see guarantee's fines
2. privacy_guarantor_fines = 1 => allow guarantor to see guarantee's fines

To test:
1) git reset --hard master
2) apply patches (including dependencies)
3) perl installer/data/mysql/updatedatabase.pl
4) dbic
5) restart_all
6) in intranet search for AllowPatronToSetFinesVisibilityForGuarantor and AllowStaffToSetFinesVisibilityForGuarantor preferences
SUCCESS => both preferences should be present
7) search for a patron with guarantor
SUCCESS => in details tab, in "Library use" section you should see a row labeled "Show fines to guarantor"
8) edit
CHECK => in Guarantor information there is no "Show fines to guarantor" select
9) set AllowStaffToSetFinesVisibilityForGuarantor preference to "Allow"
10) return to patron with guarantor and edit
SUCCESS => in Guarantor information section there is a "Show fines to guarantor" select
11) change "Show fines to guarantor" select to "Yes" and save
SUCCESS => Value is saved
12) go to details tab
SUCCESS => in "Library use" section you see a row labeled "Show fines to guarantor" with value "Yes"
13) set OPACPrivacy preference to "Allow"
14) open 2 opacs, one with a patron that has a guarantor and another that hasn't and go to "your privacy" tab.
CHECK => in both opacs you should not see a "Allow your guarantor to view your current fines?" select
15) in intranet set AllowPatronToSetFinesVisibilityForGuarantor to "Allow"
16) refresh both opacs
SUCCESS => in Patron that has guarantor you see a "Allow your guarantor to view your current fines?" select
	=> in Patron without guarantor you don't see a "Allow your guarantor to view your current fines?" select
17) in Patron with guarantor change value of select and save
SUCCESS => Value is saved
18) in intranet set OPACPrivacy preference to "Don't allow" and AllowPatronToSetFinesVisibilityForGuarantor to "Don't allow"
19) got to "your personal details" in both opacs
CHECK => in both opacs you should not see no Privacy section with a "Allow your guarantor to view your current fines?" select
20) in intranet set AllowPatronToSetFinesVisibilityForGuarantor to "Allow"
21) refresh both opacs
SUCCESS => in Patron that has guarantor you see a "Allow your guarantor to view your current fines?" select in a Privacy section
        => in Patron without guarantor there is no Privacy section
22) in Patron with guarantor change value of select and update
SUCCESS => Value is saved
23) Sign off

Signed-off-by: Agustin Moyano <agustinmoyano@theke.io>
Comment 34 Agustín Moyano 2019-08-20 18:24:21 UTC
Created attachment 92387 [details] [review]
Bug 20691: Implement fines view

This patch implements the logic to show guarantee's fines with guarantor user.

To test:
1) Apply (if not already done) steps 1 to 5 of previous patch
2) Apply this patch
3) Set OPACFinesTab and AllowStaffToSetFinesVisibilityForGuarantor preference to "Allow"
4) Find a guarantee and in accounting create a manual invoice
5) Enter OPAC with guarantor user
CHECK => In summary there is no "Relatives fines" tab
6) On intranet edit guarantee and set "Show fines to guarantors" to "Yes" and save
7) Reload guarantor's OPAC
SUCCESS => You see a "Relatives fines" tab with guarantee's fines information
8) Sign off

Signed-off-by: Agustin Moyano <agustinmoyano@theke.io>
Comment 35 Agustín Moyano 2019-08-20 18:24:25 UTC
Created attachment 92388 [details] [review]
Bug 20691: (follow-up) Fix qa fails
Comment 36 Kyle M Hall 2019-08-28 10:20:22 UTC
Created attachment 92485 [details] [review]
Bug 20691: (follow-up) Fix qa fails

Signed-off-by: Kyle M Hall <kyle@bywatersolutions.com>
Comment 37 Tomás Cohen Arazi 2019-09-10 18:32:36 UTC
Created attachment 92700 [details] [review]
Bug 20691: Database update

Signed-off-by: Agustin Moyano <agustinmoyano@theke.io>
Signed-off-by: Tomas Cohen Arazi <tomascohen@theke.io>
Comment 38 Tomás Cohen Arazi 2019-09-10 18:32:41 UTC
Created attachment 92701 [details] [review]
Bug 20691: Add ability to turn feature on and off

This patch adds two preferences
1. AllowPatronToSetFinesVisibilityForGuarantor: Allow/Don't allow patrons to choose their own privacy settings for showing the patron's fines to the patron's guarantor
2. AllowStaffToSetFinesVisibilityForGuarantor: Allow/Don't allow staff to set the ability for a patron's fines to be viewed by linked patrons in the OPAC

Also adds a tinyint, non nullable, default to 0 column in borrower and deletedborrower named privacy_guarantor_fines.
1. privacy_guarantor_fines = 0 => don't allow guarantor to see guarantee's fines
2. privacy_guarantor_fines = 1 => allow guarantor to see guarantee's fines

To test:
1) git reset --hard master
2) apply patches (including dependencies)
3) perl installer/data/mysql/updatedatabase.pl
4) dbic
5) restart_all
6) in intranet search for AllowPatronToSetFinesVisibilityForGuarantor and AllowStaffToSetFinesVisibilityForGuarantor preferences
SUCCESS => both preferences should be present
7) search for a patron with guarantor
SUCCESS => in details tab, in "Library use" section you should see a row labeled "Show fines to guarantor"
8) edit
CHECK => in Guarantor information there is no "Show fines to guarantor" select
9) set AllowStaffToSetFinesVisibilityForGuarantor preference to "Allow"
10) return to patron with guarantor and edit
SUCCESS => in Guarantor information section there is a "Show fines to guarantor" select
11) change "Show fines to guarantor" select to "Yes" and save
SUCCESS => Value is saved
12) go to details tab
SUCCESS => in "Library use" section you see a row labeled "Show fines to guarantor" with value "Yes"
13) set OPACPrivacy preference to "Allow"
14) open 2 opacs, one with a patron that has a guarantor and another that hasn't and go to "your privacy" tab.
CHECK => in both opacs you should not see a "Allow your guarantor to view your current fines?" select
15) in intranet set AllowPatronToSetFinesVisibilityForGuarantor to "Allow"
16) refresh both opacs
SUCCESS => in Patron that has guarantor you see a "Allow your guarantor to view your current fines?" select
	=> in Patron without guarantor you don't see a "Allow your guarantor to view your current fines?" select
17) in Patron with guarantor change value of select and save
SUCCESS => Value is saved
18) in intranet set OPACPrivacy preference to "Don't allow" and AllowPatronToSetFinesVisibilityForGuarantor to "Don't allow"
19) got to "your personal details" in both opacs
CHECK => in both opacs you should not see no Privacy section with a "Allow your guarantor to view your current fines?" select
20) in intranet set AllowPatronToSetFinesVisibilityForGuarantor to "Allow"
21) refresh both opacs
SUCCESS => in Patron that has guarantor you see a "Allow your guarantor to view your current fines?" select in a Privacy section
        => in Patron without guarantor there is no Privacy section
22) in Patron with guarantor change value of select and update
SUCCESS => Value is saved
23) Sign off

Signed-off-by: Agustin Moyano <agustinmoyano@theke.io>
Signed-off-by: Tomas Cohen Arazi <tomascohen@theke.io>
Comment 39 Tomás Cohen Arazi 2019-09-10 18:32:49 UTC
Created attachment 92702 [details] [review]
Bug 20691: Implement fines view

This patch implements the logic to show guarantee's fines with guarantor user.

To test:
1) Apply (if not already done) steps 1 to 5 of previous patch
2) Apply this patch
3) Set OPACFinesTab and AllowStaffToSetFinesVisibilityForGuarantor preference to "Allow"
4) Find a guarantee and in accounting create a manual invoice
5) Enter OPAC with guarantor user
CHECK => In summary there is no "Relatives fines" tab
6) On intranet edit guarantee and set "Show fines to guarantors" to "Yes" and save
7) Reload guarantor's OPAC
SUCCESS => You see a "Relatives fines" tab with guarantee's fines information
8) Sign off

Signed-off-by: Agustin Moyano <agustinmoyano@theke.io>
Signed-off-by: Tomas Cohen Arazi <tomascohen@theke.io>
Comment 40 Tomás Cohen Arazi 2019-09-10 18:32:53 UTC
Created attachment 92703 [details] [review]
Bug 20691: (follow-up) Fix qa fails

Signed-off-by: Kyle M Hall <kyle@bywatersolutions.com>
Comment 41 Tomás Cohen Arazi 2019-09-10 18:32:57 UTC
Created attachment 92704 [details] [review]
Bug 20691: (QA follow-up) Fix atomic update

Signed-off-by: Tomas Cohen Arazi <tomascohen@theke.io>
Comment 42 Tomás Cohen Arazi 2019-09-10 18:33:01 UTC
Created attachment 92705 [details] [review]
Bug 20691: (QA follow-up) API-related fixes

Signed-off-by: Tomas Cohen Arazi <tomascohen@theke.io>
Comment 43 Tomás Cohen Arazi 2019-09-10 19:01:32 UTC
Ok, I tested all the use cases described and it works correctly.
My first impression was this needed to be failed and redone. This is because it is obviously pre-API and as such some ways of doing things introduce some technical debt (more on /svc?).
I then noticed it was actually replicating what is done for checkouts privacy policy, and talking with Martin we agreed this shouldn't be blocked by this, and also, fixing it is pretty simple :-D

So PQA, and I submitted this proposal to be voted tomorrow:
https://wiki.koha-community.org/wiki/Public_patrons_privacy_endpoints_RFC

I will also file a separate bug now, depending on this one, implementing the proposed (and damn simple) new-style API and replacing the svc scripts.

Great job all!
Comment 44 Martin Renvoize 2019-09-11 07:52:46 UTC
Great work getting through that QA Tomas, thankyou for all your efforts here getting it past the last hurdle.. and thanks all involved for getting it coded up in the first place :)
Comment 45 Martin Renvoize 2019-09-12 07:44:15 UTC
Nice work!

Pushed to master for 19.11.00
Comment 46 Tomás Cohen Arazi 2019-09-17 13:45:30 UTC
Created attachment 92897 [details] [review]
Bug 20691: (QA follow-up) Fix self-reg

Signed-off-by: Tomas Cohen Arazi <tomascohen@theke.io>
Comment 47 Martin Renvoize 2019-09-17 13:48:49 UTC
Followup pushed, thanks Tomas